/*
 * ProFrom - Professzionális Felhasználói Felületek $Id: proform.merging.js,v 1.6 2005/12/08 10:09:39 gyuris Exp $
 */

proform.merging = {
	config : {
		removeTitle : 'Aktuális blokk törlése az összevonásból',
		addTitle : 'Aktuális blokk hozzáadása az összevonáshoz',
		cssSelectedBlock : 'selectedblock',
		sideSeparatorBefore : ':',
		sideSeparatorAfter : '',
		sideRegExp : /:a/g,
		sideRegExpStart : /(.+)(:a|:b)/,
		sideSelectedValue : 1
	},
	setConfig: function( sConfig, sValue ) {
		this.config[sConfig] = sValue;
	},
	groups : {},
	initForm : proform.initForm,
	addGroup : function( oGroup ) {
		var i, oGroupB, sFunction, sOT;
		// merging csoportok
		proform.merging.groups[oGroup.id] = {
			repeat : ( typeof oGroup.repeat != 'undefined' && oGroup.repeat == true ) ? true : false, 
			required : ( typeof oGroup.required != 'undefined' && oGroup.required == true ) ? true : false
		};
		// ellenőrzések lecserélése: a feltételbe belekerül: oT.toggle.value == 1 &&
		sFunction = String( oGroup.processor );
		sOT = sFunction.match( /function\s*\(\s*(\w+)/ )[1];
		eval( 'oGroup.processor = ' + sFunction
		    .replace( /proform.condition.required\(/g, 'proform.condition.required(' + sOT + '.' + oGroup.toggle + '.value==' + proform.merging.config.sideSelectedValue + ' && '  )
		    .replace( /proform.condition.warning\(/g,  'proform.condition.warning(' +  sOT + '.' + oGroup.toggle + '.value==' + proform.merging.config.sideSelectedValue + ' && '  )
		    );
		// a csoport elemeinek átalakítása :a oldalira
		oGroup.mode = 2;
		oGroup.id = oGroup.id + proform.merging.config.sideSeparatorBefore + 'a' + proform.merging.config.sideSeparatorAfter;
		oGroup.toggle = oGroup.toggle + proform.merging.config.sideSeparatorBefore + 'a' + proform.merging.config.sideSeparatorAfter;
		for ( i = 0; i < oGroup.elements.length; i++ ) {
			oGroup.elements[i] = oGroup.elements[i] + proform.merging.config.sideSeparatorBefore + 'a' + proform.merging.config.sideSeparatorAfter;
		};
		oGroup.elements.push( oGroup.toggle );
		// :b csoport a módosított :a alapján
		oGroupB = {
			id : oGroup.id.replace( proform.merging.config.sideRegExp, proform.merging.config.sideSeparatorBefore + 'b' + proform.merging.config.sideSeparatorAfter ),
			elements : [],
			processor : function() {},
			toggle : oGroup.toggle.replace( proform.merging.config.sideRegExp, proform.merging.config.sideSeparatorBefore + 'b' + proform.merging.config.sideSeparatorAfter ),
			mode : 2
		};
		for ( i = 0; i < oGroup.elements.length; i++ ) {
			oGroupB.elements[i] = oGroup.elements[i].replace( proform.merging.config.sideRegExp, proform.merging.config.sideSeparatorBefore + 'b' + proform.merging.config.sideSeparatorAfter );
		};
		eval( 'oGroupB.processor = ' + String( oGroup.processor ).replace( proform.merging.config.sideRegExp, proform.merging.config.sideSeparatorBefore + 'b' + proform.merging.config.sideSeparatorAfter) );
		if ( typeof oGroup.repeat != 'undefined' && oGroup.repeat == true ) {
			oGroupB.repeat = true;
		};
		if ( typeof oGroup.validate != 'undefined' && oGroup.validate == true ) {
			oGroupB.validate = true;
		};
		// normális addGroup az átalakítás után
		proform.addGroup( oGroup, true );
		proform.addGroup( oGroupB, true );
	},
	add : function( el ) {
		var elRoot, sId, elReverseRoot;
		elRoot = el.parentNode.parentNode.parentNode.parentNode;
		sId = elRoot.parentNode.id.match( proform.merging.config.sideRegExpStart )[1];
		addClass( el, proform.config.disabled );
		if ( proform.merging.groups[sId].repeat == false ) {
			elReverseRoot = document.getElementById( sId + proform.merging.config.sideSeparatorBefore + ( elRoot.parentNode.id.endsWith( 'a' + proform.merging.config.sideSeparatorAfter ) ? 'b' : 'a' ) + proform.merging.config.sideSeparatorAfter );
			if ( elReverseRoot ) {
				proform.merging.remove( elReverseRoot.tBodies[0].pfME.remove );
				addClass( elReverseRoot.tBodies[0].pfME.remove, proform.config.disabled );
			};
			if ( !proform.merging.groups[sId].required ) {
				removeClass( elRoot.pfME.remove, proform.config.disabled );
			};
		}
		else {
			removeClass( elRoot.pfME.remove, proform.config.disabled );
		};
		addClass( elRoot, proform.merging.config.cssSelectedBlock );
		elRoot.pfME.toggle.value = 1;
		if ( !proform.merging.groups[sId].required ) {
			proform.process( elRoot.parentNode, 'onMergingModify' );
		};
	},
	remove : function( el ) {
		//if ( hasClass( el, proform.config.disabled ) ) return;
		var elRoot, sId;
		elRoot = el.parentNode.parentNode.parentNode.parentNode;
		sId = elRoot.parentNode.id.match( proform.merging.config.sideRegExpStart )[1];
		addClass( el, proform.config.disabled );
		removeClass( elRoot.pfME.add, proform.config.disabled );
		removeClass( elRoot, proform.merging.config.cssSelectedBlock );
		elRoot.pfME.toggle.value = 0;
		proform.process( elRoot.parentNode, 'onMergingModify' );
	},
	selectSide : function( el, elOtherSide, sSideId ) {
		var i, j, elRootX, elRootY ;
		// csoportok kiejelölése/visszavonása
		for ( i in proform.merging.groups ) {
			elRootX = document.getElementById( i + proform.merging.config.sideSeparatorBefore + ( sSideId == 'a' ? 'b' : 'a' ) + proform.merging.config.sideSeparatorAfter );
			elRootY = document.getElementById( i + proform.merging.config.sideSeparatorBefore + sSideId + proform.merging.config.sideSeparatorAfter );
			if ( proform.merging.groups[i].repeat == false ) {
				if ( elRootX ) proform.merging.remove( elRootX.tBodies[0].pfME.add ); // a nem ismételhető elemek táblázata mindig meg kell legyen
				if ( elRootY ) proform.merging.add( elRootY.tBodies[0].pfME.add );
			}
			else {
				if ( elRootY ) { // ha nincs egy elem sem, akkor table sincs
					for ( j = 0; j < elRootY.tBodies.length; j++ ) {
						proform.merging.add( elRootY.tBodies[j].pfME.add );
					};
				};
			};
		};
		// gomb kizárása
		proform.helper.activeForm.disableElement( ( !el.disabled ) ? true : false, el );
		proform.helper.activeForm.disableElement( ( !el.disabled ) ? true : false, elOtherSide );
	},
	createPanel : function( elTBody, bUpdate ) {
		var elPanel, pfME;
		function createButton( sClass, sTitle, fClick ) {
			var elButton;
			elButton = document.createElement('span');
			elButton.className = sClass;
			elButton.setAttribute( 'type', 'proformpanelbutton' );
			elButton.setAttribute( 'title', sTitle );
			elButton.setAttribute( 'onclick', fClick );
			return elButton;
		};
		if ( typeof proform.merging.panelBase == 'undefined' ) { // teljesítmény miatt ezt fogjuk csak másolni
			elPanel = document.createElement('div');
			elPanel.className = proform.config.panel;
			elPanel.appendChild( createButton( proform.config.remove,   proform.merging.config.removeTitle,   'if ( !hasClass( this, proform.config.disabled ) ) { proform.merging.remove( this ) }' ) );
			elPanel.appendChild( createButton( proform.config.add,      proform.merging.config.addTitle,      'if ( !hasClass( this, proform.config.disabled ) ) { proform.merging.add( this ) }' ) );
			proform.merging.panelBase = elPanel;
		};
		if ( is.ie ) { // teljesítménykülönbség miatt más módszerrel
			elTBody.rows[0].cells[0].innerHTML += proform.merging.panelBase.outerHTML;
			elTBody.pfME = elTBody.rows[0].cells[0].lastChild;
		}
		else {
			elTBody.pfME = proform.merging.panelBase.cloneNode( true );
			elTBody.rows[0].cells[0].appendChild( elTBody.pfME );
		};
		elTBody.pfME.remove   = elTBody.pfME.childNodes[0];
		elTBody.pfME.add      = elTBody.pfME.childNodes[1];
		proform.helper.activeForm.update( elTBody );
	},
	init : function() {
		var i, j, elRoot;
		proform.setConfig( 'showRepetitionPanel', false );
		proform.setConfig( 'autoInsertText', false );
		for ( i in proform.merging.groups ) {
			if ( ( elRoot = document.getElementById( i + proform.merging.config.sideSeparatorBefore + 'b' + proform.merging.config.sideSeparatorAfter ) ) != null ) {
				for ( j = 0; j < elRoot.tBodies.length; j++ ) {
					proform.merging.createPanel( elRoot.tBodies[j] );
					elRoot.tBodies[j].pfME.toggle = document.getElementById( elRoot.pfConfig.toggle + ( elRoot.pfConfig.repeat ? proform.config.repetitionSeparatorIdBefore + j + proform.config.repetitionSeparatorIdAfter : '' ) );
					addClass( elRoot.tBodies[j].pfME.remove, proform.config.disabled );
				};
			};
			if ( ( elRoot = document.getElementById( i + proform.merging.config.sideSeparatorBefore + 'a' + proform.merging.config.sideSeparatorAfter ) ) != null ) {
				for ( j = 0; j < elRoot.tBodies.length; j++ ) {
					proform.merging.createPanel( elRoot.tBodies[j] );
					addClass( elRoot.tBodies[j].pfME.remove, proform.config.disabled );
					elRoot.tBodies[j].pfME.toggle = document.getElementById( elRoot.pfConfig.toggle + ( elRoot.pfConfig.repeat ? proform.config.repetitionSeparatorIdBefore + j + proform.config.repetitionSeparatorIdAfter : '' ) );
					if ( proform.merging.groups[i].required ) { // ezért van előbb a B oldal inicializálva
						proform.merging.add( elRoot.tBodies[j].pfME.add );
					};
				};
			};
		};
		proform.init();
	}
};
 