<?php
header ("Content-Type: text/xml");
header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");              // Date in the past
header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
header ("Cache-Control: no-cache, must-revalidate");            // HTTP/1.1
header ("Pragma: no-cache");   

if ( $_GET['action'] == 'userValidation' ) {
	// XML feldolgozása
	$xml_string = $HTTP_RAW_POST_DATA;
	$xml_values = null;
	$tags       = null;

	$parser = xml_parser_create( "UTF-8" );
	xml_parser_set_option( $parser, XML_OPTION_CASE_FOLDING, 0);
	xml_parser_set_option( $parser, XML_OPTION_SKIP_WHITE, 1 );
	if ( !xml_parse_into_struct( $parser, $xml_string, $xml_values, $tags ) ) { // ha nem sikerül a kapott xml-t elemezni
		exit;
	}
	xml_parser_free( $parser );
	
	$userName = "";
	$password = "";
	for ( $i = 0; $i < sizeof( $xml_values ); $i++ ) {
		if ( $xml_values[ $i ][ "tag" ] == "userName" || $xml_values[ $i ][ "tag" ] == "password" ) {
			${$xml_values[ $i ][ "tag" ]} = $xml_values[ $i ][ "value" ];
		}
	}

	echo '<?xml version="1.0" encoding="UTF-8"?>'."\n";
	echo '<response action="userValidation">'."\n";
	if ( $userName == 'gyuris' && $password == 'gumicsirke' ) {
		echo '  <login>1</login>';
	}
	else {
		echo '  <login>0</login>';
	};
	echo '</response>'."\n";
}
elseif ( $_GET['action'] == 'getEvent' ) {
	echo '<?xml version="1.0" encoding="UTF-8"?>'."\n";
	echo '<response action="getEvent">'."\n";
	echo '  <option value="1">1</option>'."\n";
	echo '  <option value="2">2</option>'."\n";
	echo '  <option value="3">3</option>'."\n";
	echo '  <option value="4">4</option>'."\n";
	echo '  <option value="5">5</option>'."\n";
	echo '  <option value="6">6</option>'."\n";
	echo '  <option value="6">a kérés volt:'.$_GET['group'].'</option>'."\n";
	echo '</response>'."\n";
}
elseif ( $_GET['action'] == 'getUser' ) {
	parse_str( $HTTP_RAW_POST_DATA );
	echo '<?xml version="1.0" encoding="UTF-8"?>'."\n";
	echo '<response action="getUser">'."\n";
	if ( $username == 'gyuris' ) {
		echo '  <validusername>0</validusername>'."\n";
	}
	else {
		echo '  <validusername>1</validusername>'."\n";
	};
	echo '  <username>'.$_POST['username'].'</username>'."\n";
	echo '</response>'."\n";
}
elseif ( $_GET['action'] == 'getQuick' ) {
	parse_str( $HTTP_RAW_POST_DATA );
	echo '<?xml version="1.0" encoding="UTF-8"?>'."\n";
	echo '<response action="getQuick">'."\n";
	if ( $quick == 'gyur' ) {
		echo '  <user><id>0</id><name>Gyuris Gellért</name></user>'."\n";
		echo '  <user><id>1</id><name>Gyuranik Zsolt</name></user>'."\n";
		echo '  <user><id>2</id><name>Gyurcsok Barnabás</name></user>'."\n";
		echo '  <user><id>3</id><name>Gyurika Pál</name></user>'."\n";
		echo '  <user><id>4</id><name>Gyuranics László</name></user>'."\n";
		echo '  <user><id>5</id><name>Gyula Klára</name></user>'."\n";
	};
	echo '</response>'."\n";
}
elseif ( $_GET['action'] == 'getComplex' ) {
	parse_str( $HTTP_RAW_POST_DATA );
	echo '<?xml version="1.0" encoding="UTF-8"?>'."\n";
	echo '<response action="getComplex">'."\n";
	if ( $fullname == 'gyur' ) {
		echo '  <user><id>8</id><invocation></invocation><name_last>Gyuris</name_last><name_first>Gellért</name_first><name_virgin></name_virgin><year>1977.12.20</year><sex>m</sex><subscription>bubu</subscription><scope_of_duties>0,1,1,0,1</scope_of_duties></user>'."\n";
		echo '  <user><id>9</id><invocation>Dr.</invocation><name_last>Gyuranik</name_last><name_first>Zsolt</name_first><name_virgin></name_virgin><year>1967.02.21</year><sex>m</sex><subscription></subscription><scope_of_duties>0,0,1,1,1</scope_of_duties></user>'."\n";
		echo '  <user><id>2</id><invocation>dr.</invocation><name_last>Gyurka</name_last><name_first>Anita</name_first><name_virgin>Petrezselyem Anita</name_virgin><year>1984.11.10</year><sex>f</sex><subscription>anitácska</subscription><scope_of_duties>1,1,1,1,1</scope_of_duties></user>'."\n";
	};
echo '</response>'."\n";
}
?>