/*
 * ProFrom - Professzionális Felhasználói Felületek $Id: proform.pager.js,v 1.3 2005/12/06 15:18:31 gyuris Exp $
 */

/** 
 * pager 
 */
pager = {
	setOrderbyCode : function( el, nOrderByCode ) {
		var elOrder = getPreviousElement( el.parentNode.parentNode.parentNode ).getElementsByTagName('input')[0];
		if ( elOrder.value == nOrderByCode ) {  // fordított rendezés
			nOrderByCode *= -1; 
		};
		elOrder.value = nOrderByCode;
		elOrder.form.submit();	
	},
	moveCursor: function( el, nDirection ) {
		var elSelect = getPreviousElement( el.parentNode ).getElementsByTagName('select')[0], i;
		for ( i = 0; i < elSelect.options.length; i++ ) {
			if ( elSelect.options[i].selected ) {
				elSelect.options[i+nDirection].selected = true;
				elSelect.form.submit();
				break;
			}
		};
	}
};

/** 
 * filter
 */
filter = {
	config : {
		alternateText : 'A szűrőfeltételek módosításához kattintson ide.'
	},
	setConfig: function( sConfig, sValue ) {
		this.config[sConfig] = sValue;
	},
	hideFilter : function( el ) {
		var elGroup;
		elGroup = getPreviousElement( el.parentNode ).getElementsByTagName('table')[0];
		addClass( el.parentNode, proform.config.insertNonVisible ); 
		addClass( elGroup, proform.config.insertNonVisible );
		removeClass( elGroup.insertObj, proform.config.insertNonVisible ); 
		elGroup.insertObj.firstChild.data = filter.config.alternateText;
	},
	removeFilter : function () {
		proform.setConfig( 'overwriteSubmit', true );
	},
	showFilter : function( elTable ) {
		removeClass( getNextElement( elTable.parentNode ), proform.config.insertNonVisible );
	}
};
