textareaAutoHeight = {
	config : {},
	init : function( el ) {
		el.lastHeightUpdate = new Date().setSeconds( -1 );
		el.lastTextLength = el.textLength || el.value.length;
		el.delta = el.offsetHeight - el.clientHeight;
		el.minHeight = parseInt( getComputedStylePropertyValue( el, 'min-height', '' ) );
		addEvent( el, 'keyup', textareaAutoHeight.updateHeight );
		addEvent( el, 'focus', textareaAutoHeight.updateHeight );
	},
	updateHeight : function( e ) {
		var e = ( !e ) ? window.event : e;
		var el = ( is.ie ) ? e.srcElement : this;
		if ( e.keyCode != 13 && new Date() - el.lastHeightUpdate < 500 ) {
			return false;
		};
		if ( el.value.length < el.lastTextLength ) {
			el.style.height = el.minHeight + 'px';
		};
		el.style.height = ( is.ie ) ? el.scrollHeight + el.delta + 'px' : el.scrollHeight + 'px';
		el.style.overflow = 'hidden';
		if ( is.ie ) { // min height
			if ( el.scrollHeight <= el.minHeight ) {
				el.style.height = el.minHeight + 'px';
			};
		};
		el.lastTextLength = el.value.length;
		el.lastHeightUpdate = new Date();
	}
};